----- notAmap BUILDERS LIBRARY -----

--! all big numbers params for findCoast filter should be bigger, 4*4*current_value and rescaled by tileSize in application

builder = {
	["ringier"] = {
		-- THIS BUILDER IS DONE FOR tileSize = 4
		--{name = "getCentredRectRing", 	params = {0.05,0.7}, 	recentMap = false}, -- GOOD PARAMS --
		{name = "getRectangle", 			params = {true,0.05,0.05,0.95,0.95}, 	recentMap = false},
		{name = "getDetCentredRectangle", 	params = {false,0.5,0.5,"advancedCirclePosition",0.38,0.05,fullMapHash % 9}, 	recentMap = true},
		{name = "getDetCentredRectangle", 	params = {false,0.5,0.5,"advancedCirclePosition",0.44,0.1,fullMapHash % 9}, 	recentMap = true},
		--{name = "getCentredRectRing", 	params = {0.0,0.2}, 	recentMap = false},
		--{name = "getRectangle", 	params = {0.5,0.25,0.7,0.38}, 	recentMap = false},
		{name = "findCoast", 				params = {3,{260000},{{0,0,1,1}}}, 			recentMap = true},
		-- {name = "getRectangle", 		params = {false,0.55,0.5,0.02}, 				recentMap = true},  --- add random position of isle
		{name = "getDetCentredRectangle", 	params = {false,0.5,0.5,"advancedCirclePosition",0.12,0.01,mask["revertRing"](fullMapHash % 9) - 1}, 	recentMap = true},
		{name = "getDetCentredRectangle", 	params = {false,0.5,0.5,"advancedCirclePosition",0.12,0.01,mask["revertRing"](fullMapHash % 9),"centerIsle"}, 	recentMap = true},
		{name = "getDetCentredRectangle", 	params = {false,0.5,0.5,"advancedCirclePosition",0.12,0.01,mask["revertRing"](fullMapHash % 9) + 1}, 	recentMap = true},
		{name = "findCoast", 				params = {3.6,{18000},{{0.35,0.35,0.65,0.65}}}, 	recentMap = true},
		{name = "addLevel", 				params = {-60}, recentMap = true},
		{name = "generalSmooth", 			params = {3,false}, 	recentMap = true},
		--{name = "generalSmooth", 			params = {2,false}, 	recentMap = true},
		--{name = "generalSmooth", 			params = {1,false}, 	recentMap = true},
		--{name = "smoothCoast", 				params = {4,10}, 		recentMap = true},
		--{name = "getCentredRectRing", 	params = {50,65}, 	recentMap = false},
		--{name = "addLevel", 			params = {100}, 	recentMap = true},
		{name = "applyChanges", 			params = {}, 	recentMap = true},
		{name = "secondarySmooth", 			params = {}, 	recentMap = true}, --- only one prepared for tileSize = 4 only
		{name = "selectedFinalSmooth", 		params = {}, 	recentMap = true},
		--{name = "selectedFinalSmooth", 				params = {}, 	recentMap = true},
		--{name = "selectedFinalSmooth", 				params = {}, 	recentMap = true},
		--{name = "finalSmooth", 				params = {}, 	recentMap = true},
		--{name = "finalSmooth", 				params = {}, 	recentMap = true},
		--{name = "finalSmooth", 				params = {}, 	recentMap = true},
	},
	["invertedRingier"] = {
		{name = "getRectangle", 			params = {true,0,0,1,1}, 	recentMap = false},
		{name = "addLevel", 				params = {-60}, recentMap = true},
		{name = "getRectangle", 			params = {true,0.05,0.05,0.95,0.95}, 	recentMap = false},
		{name = "getDetCentredRectangle", 	params = {false,0.5,0.5,"advancedCirclePosition",0.38,0.05,fullMapHash % 9}, 	recentMap = true},
		{name = "getDetCentredRectangle", 	params = {false,0.5,0.5,"advancedCirclePosition",0.44,0.1,fullMapHash % 9}, 	recentMap = true},
		{name = "findCoast", 				params = {3,{260000},{{0,0,1,1}}}, 			recentMap = true},
		{name = "getDetCentredRectangle", 	params = {false,0.5,0.5,"advancedCirclePosition",0.12,0.01,mask["revertRing"](fullMapHash % 9) - 1}, 	recentMap = true},
		{name = "getDetCentredRectangle", 	params = {false,0.5,0.5,"advancedCirclePosition",0.12,0.01,mask["revertRing"](fullMapHash % 9),"centerIsle"}, 	recentMap = true},
		{name = "getDetCentredRectangle", 	params = {false,0.5,0.5,"advancedCirclePosition",0.12,0.01,mask["revertRing"](fullMapHash % 9) + 1}, 	recentMap = true},
		{name = "findCoast", 				params = {3.6,{18000},{{0.35,0.35,0.65,0.65}}}, 	recentMap = true},
		{name = "addLevel", 				params = {60}, recentMap = true},
		{name = "generalSmooth", 			params = {3,false}, 	recentMap = true},
		{name = "applyChanges", 			params = {}, 	recentMap = true},
		{name = "secondarySmooth", 			params = {}, 	recentMap = true}, --- only one prepared for tileSize = 4 only
		{name = "selectedFinalSmooth", 		params = {}, 	recentMap = true},
	},
	["lakeInTheCenter"] = {
		{name = "getRectangle", 			params = {true,0.37,0.37,0.63,0.63}, 	recentMap = false},
		{name = "findCoast", 				params = {3,{25000},{{0,0,1,1}}}, 	recentMap = true},
		{name = "addLevel", 				params = {-60}, recentMap = true},
		{name = "generalSmooth", 			params = {3,false}, 	recentMap = true},
		{name = "applyChanges", 			params = {}, 	recentMap = true},
		{name = "secondarySmooth", 			params = {}, 	recentMap = true}, --- only one prepared for tileSize = 4 only
		{name = "selectedFinalSmooth", 		params = {}, 	recentMap = true},
	},	
	["outRingHills"] = {
		-- corners
		{name = "randomHillGlobal",			params = {fullMapHash,0.2,0.05,"allArchHills",200,2500,0,0.7}, recentMap = false},
		{name = "randomHillGlobal",			params = {fullMapHash,0.05,0.2,"allArchHills",200,2500,0,0.7}, recentMap = false},
		{name = "randomHillGlobal",			params = {fullMapHash,0.8,0.95,"allArchHills",200,2500,0,0.7}, recentMap = false},
		{name = "randomHillGlobal",			params = {fullMapHash,0.95,0.8,"allArchHills",200,2500,0,0.7}, recentMap = false},
		{name = "randomHillGlobal",			params = {fullMapHash,0.05,0.8,"allArchHills",200,2500,0,0.7}, recentMap = false},
		{name = "randomHillGlobal",			params = {fullMapHash,0.2,0.95,"allArchHills",200,2500,0,0.7}, recentMap = false},
		{name = "randomHillGlobal",			params = {fullMapHash,0.8,0.05,"allArchHills",200,2500,0,0.7}, recentMap = false},
		{name = "randomHillGlobal",			params = {fullMapHash,0.95,0.2,"allArchHills",200,2500,0,0.7}, recentMap = false},
		
		-- north
		{name = "randomHillGlobal",			params = {fullMapHash,0.07,0.4,"allArchHills",500,2000,0,0.4}, recentMap = false},
		{name = "randomHillGlobal",			params = {fullMapHash,0.03,0.6,"allArchHills",500,2000,0,0.5}, recentMap = false},
		
		-- east
		{name = "randomHillGlobal",			params = {fullMapHash,0.4,0.03,"allArchHills",500,2000,0,0.4}, recentMap = false},
		{name = "randomHillGlobal",			params = {fullMapHash,0.6,0.07,"allArchHills",500,2000,0,0.5}, recentMap = false},
		
		-- south
		{name = "randomHillGlobal",			params = {fullMapHash,0.93,0.4,"allArchHills",500,2000,0,0.4}, recentMap = false},
		{name = "randomHillGlobal",			params = {fullMapHash,0.97,0.6,"allArchHills",500,2000,0,0.5}, recentMap = false},
		
		-- west
		{name = "randomHillGlobal",			params = {fullMapHash,0.4,0.93,"allArchHills",500,2000,0,0.4}, recentMap = false},
		{name = "randomHillGlobal",			params = {fullMapHash,0.6,0.97,"allArchHills",500,2000,0,0.5}, recentMap = false},
		
		
		-- {name = "addHill", 				params = {"elvenPonds",4000,900,"s"}, recentMap = false},
		-- {name = "makeHill", 				params = {"circlePlatformSmoothed",9500,9500,320,390,90}, recentMap = true},			
	},
	["middleRingHills"] = {
		{name = "randomHillGlobal",			params = {fullMapHash,0.28,0.5,"allArchHills",500,2000,-8,0.8}, recentMap = false},
		{name = "randomHillGlobal",			params = {fullMapHash,0.37,0.62,"allArchHills",500,2000,-8,0.8}, recentMap = false},
		{name = "randomHillGlobal",			params = {fullMapHash,0.5,0.70,"allArchHills",500,2000,-8,0.8}, recentMap = false},
		{name = "randomHillGlobal",			params = {fullMapHash,0.63,0.63,"allArchHills",500,2000,-8,0.8}, recentMap = false},
		{name = "randomHillGlobal",			params = {fullMapHash,0.7,0.5,"allArchHills",500,2000,-8,0.8}, recentMap = false},
		{name = "randomHillGlobal",			params = {fullMapHash,0.65,0.38,"allArchHills",500,2000,-8,0.8}, recentMap = false},
		{name = "randomHillGlobal",			params = {fullMapHash,0.58,0.30,"allArchHills",500,200,-8,0.8}, recentMap = false},
		{name = "randomHillGlobal",			params = {fullMapHash,0.40,0.28,"allArchHills",500,2000,-8,0.8}, recentMap = false},
		{name = "randomHillGlobal",			params = {fullMapHash,0.30,0.38,"allArchHills",500,2000,-8,0.8}, recentMap = false},			
	},
	["centerHill"] = {
		-- corners
		{name = "randomHillGlobalDependant",params = {fullMapHash,"centerIsle","allArchHills",500,2000,0,1.0}, recentMap = false},
	},
	["mountainsHillsSet"] = {
		-- ! REWRITES THE BASTARD BELOW
	
		-- corners
		{name = "randomHillGlobal",params = {fullMapHash,0.2,0.25,"allArchHills",500,2000,0,0.8}, recentMap = false},
		{name = "randomHillGlobal",params = {fullMapHash,0.2,0.45,"allArchHills",500,2000,0,0.8}, recentMap = false},
		{name = "randomHillGlobal",params = {fullMapHash,0.2,0.65,"allArchHills",500,2000,0,0.8}, recentMap = false},
		{name = "randomHillGlobal",params = {fullMapHash,0.2,0.85,"allArchHills",500,2000,0,0.8}, recentMap = false},
		
		{name = "randomHillGlobal",params = {fullMapHash,0.3,0.15,"allArchHills",500,2000,0,0.8}, recentMap = false},
		{name = "randomHillGlobal",params = {fullMapHash,0.3,0.35,"allArchHills",500,2000,0,0.8}, recentMap = false},
		{name = "randomHillGlobal",params = {fullMapHash,0.3,0.55,"allArchHills",500,2000,0,0.8}, recentMap = false},
		{name = "randomHillGlobal",params = {fullMapHash,0.3,0.75,"allArchHills",500,2000,0,0.8}, recentMap = false},
		
		{name = "randomHillGlobal",params = {fullMapHash,0.4,0.25,"allArchHills",500,2000,0,0.8}, recentMap = false},
		{name = "randomHillGlobal",params = {fullMapHash,0.4,0.45,"allArchHills",500,2000,0,0.6}, recentMap = false},
		{name = "randomHillGlobal",params = {fullMapHash,0.4,0.65,"allArchHills",500,2000,0,0.6}, recentMap = false},
		{name = "randomHillGlobal",params = {fullMapHash,0.4,0.85,"allArchHills",500,2000,0,0.8}, recentMap = false},
		
		{name = "randomHillGlobal",params = {fullMapHash,0.5,0.15,"allArchHills",500,2000,0,0.8}, recentMap = false},
		{name = "randomHillGlobal",params = {fullMapHash,0.5,0.35,"allArchHills",500,2000,0,0.8}, recentMap = false},
		{name = "randomHillGlobal",params = {fullMapHash,0.5,0.55,"allArchHills",500,2000,0,0.2}, recentMap = false},
		{name = "randomHillGlobal",params = {fullMapHash,0.5,0.75,"allArchHills",500,2000,0,0.8}, recentMap = false},
		
		{name = "randomHillGlobal",params = {fullMapHash,0.6,0.25,"allArchHills",500,2000,0,0.8}, recentMap = false},
		{name = "randomHillGlobal",params = {fullMapHash,0.6,0.45,"allArchHills",500,2000,0,0.6}, recentMap = false},
		{name = "randomHillGlobal",params = {fullMapHash,0.6,0.65,"allArchHills",500,2000,0,0.6}, recentMap = false},
		{name = "randomHillGlobal",params = {fullMapHash,0.6,0.85,"allArchHills",500,2000,0,0.8}, recentMap = false},
		
		{name = "randomHillGlobal",params = {fullMapHash,0.7,0.15,"allArchHills",500,2000,0,0.8}, recentMap = false},
		{name = "randomHillGlobal",params = {fullMapHash,0.7,0.35,"allArchHills",500,2000,0,0.8}, recentMap = false},
		{name = "randomHillGlobal",params = {fullMapHash,0.7,0.55,"allArchHills",500,2000,0,0.8}, recentMap = false},
		{name = "randomHillGlobal",params = {fullMapHash,0.7,0.75,"allArchHills",500,2000,0,0.8}, recentMap = false},
		
		{name = "randomHillGlobal",params = {fullMapHash,0.8,0.25,"allArchHills",500,2000,0,0.8}, recentMap = false},
		{name = "randomHillGlobal",params = {fullMapHash,0.8,0.45,"allArchHills",500,2000,0,0.8}, recentMap = false},
		{name = "randomHillGlobal",params = {fullMapHash,0.8,0.65,"allArchHills",500,2000,0,0.8}, recentMap = false},
		{name = "randomHillGlobal",params = {fullMapHash,0.8,0.85,"allArchHills",500,2000,0,0.8}, recentMap = false},
		
		--{name = "applyTexture",params = {1,1}, recentMap = false},
	},
	["mountainsHillsSet2"] = {
		-- corner		
		--{name = "applyTexture",params = {1,1}, recentMap = false},
	},
	["basicMetalMaker"] = {
		--{name = "simpleMetalDigger", 		params = {50}, recentMap = true},	
		{name = "rectangleMetalDigger", 	params = {0.01,0.01,0.19,0.19,5}, recentMap = true},   	-- player1_site
		{name = "rectangleMetalDigger", 	params = {0.81,0.81,0.99,0.99,5}, recentMap = true},	-- player2_site
		{name = "rectangleMetalDigger", 	params = {0.81,0.01,0.99,0.19,5}, recentMap = true},	-- player3_site
		{name = "rectangleMetalDigger", 	params = {0.01,0.81,0.19,0.99,5}, recentMap = true},	-- player4_site
		
		-- x*x variant
		-- {name = "rectangleMetalDigger", 	params = {0.41,0.01,0.59,0.19,5}, recentMap = true},	-- player5_site
		-- {name = "rectangleMetalDigger", 	params = {0.41,0.81,0.59,0.99,5}, recentMap = true},	-- player6_site
		-- {name = "rectangleMetalDigger", 	params = {0.01,0.41,0.19,0.59,5}, recentMap = true},	-- player7_site
		-- {name = "rectangleMetalDigger", 	params = {0.81,0.41,0.99,0.59,5}, recentMap = true},	-- player8_site
		
		-- x*z variant
		{name = "rectangleMetalDigger", 	params = {0.41,0.01,0.59,0.12,5}, recentMap = true},	-- player5_site
		{name = "rectangleMetalDigger", 	params = {0.41,0.88,0.59,0.99,5}, recentMap = true},	-- player6_site
		{name = "rectangleMetalDigger", 	params = {0.01,0.41,0.12,0.59,5}, recentMap = true},	-- player7_site
		{name = "rectangleMetalDigger", 	params = {0.88,0.41,0.99,0.59,5}, recentMap = true},	-- player8_site
		
		{name = "rectangleMetalDigger", 	params = {0.41,0.41,0.59,0.59,12}, recentMap = true},	-- centre of the map
		{name = "rectangleMetalDigger", 	params = {0.01,0.21,0.99,0.39,6}, recentMap = true},	-- rectangle1
		{name = "rectangleMetalDigger", 	params = {0.01,0.61,0.99,0.79,6}, recentMap = true},	-- rectangle2
		{name = "rectangleMetalDigger", 	params = {0.21,0.01,0.39,0.99,6}, recentMap = true},	-- rectangle3
		{name = "rectangleMetalDigger", 	params = {0.61,0.01,0.79,0.99,6}, recentMap = true},	-- rectangle4
	},
	["centredMetalMaker"] = {
		{name = "rectangleMetalDigger", 	params = {0.01,0.01,0.19,0.19,4}, recentMap = true},   	-- player1_site
		{name = "rectangleMetalDigger", 	params = {0.81,0.81,0.99,0.99,4}, recentMap = true},	-- player2_site
		{name = "rectangleMetalDigger", 	params = {0.81,0.01,0.99,0.19,4}, recentMap = true},	-- player3_site
		{name = "rectangleMetalDigger", 	params = {0.01,0.81,0.19,0.99,4}, recentMap = true},	-- player4_site
		
		-- x*z variant
		{name = "rectangleMetalDigger", 	params = {0.41,0.01,0.59,0.12,2}, recentMap = true},	-- player5_site
		{name = "rectangleMetalDigger", 	params = {0.41,0.88,0.59,0.99,2}, recentMap = true},	-- player6_site
		{name = "rectangleMetalDigger", 	params = {0.01,0.41,0.12,0.59,2}, recentMap = true},	-- player7_site
		{name = "rectangleMetalDigger", 	params = {0.88,0.41,0.99,0.59,2}, recentMap = true},	-- player8_site
		
		{name = "rectangleMetalDigger", 	params = {0.31,0.31,0.69,0.69,14}, recentMap = true},	-- centre of the map
		{name = "rectangleMetalDigger", 	params = {0.41,0.41,0.59,0.59,22}, recentMap = true},	-- centre of the map lake
		{name = "rectangleMetalDigger", 	params = {0.01,0.21,0.99,0.39,2}, recentMap = true},	-- rectangle1
		{name = "rectangleMetalDigger", 	params = {0.01,0.61,0.99,0.79,2}, recentMap = true},	-- rectangle2
		{name = "rectangleMetalDigger", 	params = {0.21,0.01,0.39,0.99,2}, recentMap = true},	-- rectangle3
		{name = "rectangleMetalDigger", 	params = {0.61,0.01,0.79,0.99,2}, recentMap = true},	-- rectangle4
	},
}

local mountainsHillsSet2Build = {}
for i=0,10 do
	for j=0,10 do
		local index = i*11 +j + 1
		mountainsHillsSet2Build[index] = {
			name = "randomHillGlobal",
			params = {
				fullMapHash,
				i*0.068 + 0.125 + terraMath.zeroToSmallRandomizer(fullMapHash,10,0.01),
				j*0.068 + 0.125 + terraMath.zeroToSmallRandomizer(fullMapHash,10,0.01),
				"allArchHills",
				500,
				2000,
				-8,
				0.8,
			},
			recentMap = false
		}
	end
end
builder["mountainsHillsSet2"] = mountainsHillsSet2Build

local mountainsHillsSetBuild = {}
for i=0,4 do
	for j=0,4 do
		local index = i*5 +j + 1
		mountainsHillsSetBuild[index] = {
			name = "randomHillGlobal",
			params = {
				fullMapHash,
				i*0.15 + 0.125 + terraMath.zeroToSmallRandomizer(fullMapHash,10,0.02),
				j*0.15 + 0.125 + terraMath.zeroToSmallRandomizer(fullMapHash,10,0.02),
				"allNonArchHills",
				300,
				1500,
				-8,
				0.7,
			},
			recentMap = false
		}
	end
end
builder["mountainsHillsSet"] = mountainsHillsSetBuild

-- local middleRingHills = {}
-- for i=0,8 do
	-- for j=0,8 do
		-- local index = i*9 +j + 1
		-- local probability = 0.9
		-- if ((i > 3 and i < 6) or (j > 3 and j < 6)) then
			-- probability = 0
		-- end
		-- if ((i == 2 or i == 7) or (j == 2 or j == 7)) then
			-- probability = 0
		-- end
		-- if ((i == 1 or i == 8) or (j == 1 or j == 8)) then
			-- probability = 0.35
		-- end
		-- middleRingHills[index] = {
			-- name = "randomHillGlobal",
			-- params = {
				-- fullMapHash,
				-- i*0.055 + 0.25 + terraMath.zeroToSmallRandomizer(fullMapHash,10,0.004),
				-- j*0.055 + 0.25+ terraMath.zeroToSmallRandomizer(fullMapHash,10,0.004),
				-- "allArchHills",
				-- 200,
				-- 1500,
				-- -8,
				-- probability,
			-- },
			-- recentMap = false
		-- }
	-- end
-- end
-- builder["middleRingHills"] = middleRingHills