----- notAmap DIGGERS LIBRARY -----

local spSetHeightMapFunc	= Spring.SetHeightMapFunc
local spSetHeightMap		= Spring.SetHeightMap
local spAddHeightMap		= Spring.AddHeightMap 
local spLevelHeightMap		= Spring.LevelHeightMap
local spSetMetalAmount 		= Spring.SetMetalAmount
local spGetGroundHeight 	= Spring.GetGroundHeight

digger = {
	["addLevel"] = function(givenMap,height)
		for i=1,mapCount do
			if (givenMap[i]) then
				heightMap[i] = heightMap[i] + height
			end
		end
		return givenMap
	end,
	["doLevel"] = function(givenMap,height)
		for i=1,mapCount do
			if (givenMap[i]) then
				heightMap[i] = height
			end
		end
		return givenMap
	end,
	["makeHill"] = function(givenMap,hillName,posX,posZ,param1,param2,param3) --- not using givenMap => use true
		procEl[hillName](posX,posZ,param1,param2,param3)
		return givenMap
	end,
	["addHill"] = function(givenMap,hillName,posX,posZ,moveY,rotation) --- not using givenMap => use true
		local sizeX 		= maskEl[hillName].sizeX
		local sizeZ 		= maskEl[hillName].sizeZ
		local stepsX 		= maskEl[hillName].stepsX
		local stepsZ 		= maskEl[hillName].stepsZ
		local needSmoothing = maskEl[hillName].needSmoothing
		local map			= maskEl[hillName].map
		
		-- !! plan is to have here rotator (4 ways) and smoother... but now just simple print for one rotation
		-- ! before here was "need smooth" checker, but now its broken with presmoothed hills

		digger.addHillRotated(posX,posZ,stepsX,stepsZ,sizeX,sizeZ,moveY,map,rotation)  -- !! not completed
		return givenMap
	end,
	["addHillSimple"] = function(posX,posZ,stepsX,stepsZ,sizeX,sizeZ,moveY,map) 		
		local globalStepSize = Game.squareSize -- ! later we can save it for different setup (but not planned much)
		local tileIndex		 = 0
		
		local topX		= posX - floor(sizeX/2)
		local topZ 		= posZ - floor(sizeZ/2)
		local bottomX 	= posX + floor(sizeX/2)
		local bottomZ	= posZ + floor(sizeZ/2)
		
		Spring.SetHeightMapFunc(function()
			local controlerX = 0
			for i=topX,bottomX,globalStepSize do
				controlerX = controlerX + 1
				local controlerZ = 0
				for j=topZ,bottomZ,globalStepSize do
					tileIndex = tileIndex + 1
					controlerZ = controlerZ + 1 
					
					local newHeight = (map[tileIndex] or 0) + moveY
					if (newHeight >= 0) then
						spAddHeightMap(i,j,newHeight)
					end
					
					if (controlerZ == stepsZ) then
						break
					end
				end
				if (controlerX == stepsX) then
					break
				end
			end
		end)
	end,
	["addHillRotated"] = function(posX,posZ,stepsX,stepsZ,sizeX,sizeZ,moveY,map,rotation)
		local newMap 		= {}	
		local reallyRotated = false
		
		if		(rotation == "n") then
			newMap = map
		elseif 	(rotation == "s") then
			-- do vertical reverse
			newMap = terraMath.mapVerticalReverse(map,stepsX,stepsZ)
		elseif 	(rotation == "e") then
			-- do rotation right
			newMap = terraMath.mapRotationRight(map,stepsX,stepsZ)
			reallyRotated = true
		elseif 	(rotation == "w") then
			-- do rotation right
			newMap = terraMath.mapRotationRight(map,stepsX,stepsZ)
			reallyRotated = true
			-- do horizontal reverse
			newMap = terraMath.mapHorizontalReverse(newMap,stepsZ,stepsX)
		elseif 	(rotation == "nr") then
			-- do horizontal reverse
			newMap = terraMath.mapHorizontalReverse(map,stepsX,stepsZ)
		elseif 	(rotation == "sr") then
			-- do vertical reverse 
			newMap = terraMath.mapVerticalReverse(map,stepsX,stepsZ)
			-- do horizontal reverse
			newMap = terraMath.mapHorizontalReverse(newMap,stepsX,stepsZ)
		elseif 	(rotation == "er") then
			-- do rotation right
			newMap = terraMath.mapRotationRight(map,stepsX,stepsZ)
			reallyRotated = true
			-- do vertical reverse
			newMap = terraMath.mapVerticalReverse(newMap,stepsZ,stepsX)
		elseif 	(rotation == "wr") then
			-- do rotation right
			newMap = terraMath.mapRotationRight(map,stepsX,stepsZ)
			reallyRotated = true
			-- do vertical reverse
			newMap = terraMath.mapVerticalReverse(newMap,stepsZ,stepsX)
			-- do horizontal reverse
			newMap = terraMath.mapHorizontalReverse(newMap,stepsZ,stepsX)
		end
		
		-- debug
		-- digger.writeHill(newMap,stepsX,stepsZ)
		
		if (reallyRotated) then
			digger.addHillSimple(posX,posZ,stepsZ,stepsX,sizeZ,sizeX,moveY,newMap)
		else
			digger.addHillSimple(posX,posZ,stepsX,stepsZ,sizeX,sizeZ,moveY,newMap)
		end
		
		return newMap
	end,
	["randomHill"] = function(givenMap,hash,posX,posZ,hillsSetName,minLowerSize,maxLonegerSize,moveY,probability)
		local relativePosX = posX / mapX
		local relativePosZ = posZ / mapZ
		return digger.randomHillGlobal(givenMap,hash,relativePosX,relativePosZ,hillsSetName,minLowerSize,maxLonegerSize,moveY,probability)
	end,
	["randomHillGlobalDependant"] = function(givenMap,hash,posInfo,hillsSetName,minLowerSize,maxLonegerSize,moveY,probability)
		if (mapKnowledge[posInfo] == nil) then
			Spring.Echo("notAmap error: expected mapKnowledge with key: " .. posInfo)
		else
			local relativePosX = mapKnowledge[posInfo].x
			local relativePosZ = mapKnowledge[posInfo].z
			return digger.randomHillGlobal(givenMap,hash,relativePosX,relativePosZ,hillsSetName,minLowerSize,maxLonegerSize,moveY,probability)
		end
	end,
	["randomHillGlobal"] = function(givenMap,hash,relativePosX,relativePosZ,hillsSetName,minLowerSize,maxLonegerSize,moveY,probability)
		-- will be executed?
		if (probability ~= nil) then
			local willBe = 0
			for i=1,10 do 
				willBe = random()
			end
			if (willBe > probability) then
				return
			end
		end
		
		-- calculate positions
		local posX 			= floor(relativePosX*mapX)
		local posZ 			= floor(relativePosZ*mapZ)
		
		-- choose hillName
		local setOfHills 	= mask[hillsSetName]()
		
		-- leave if nil
		if (setOfHills == nil) then
			Spring.Echo("notAmap error: setOfHills called " .. hillsSetName .. " is empty.")
			return givenMap
		end
		
		local newHash		= terraMath.secondaryHashRandomizer(hash)
		local hillName 		= setOfHills[terraMath.sinRandomizer(newHash,#setOfHills)]
		
		-- checking hill size if wanted
		if (maxLonegerSize ~= nil) then
			local satisfied = false
			for i=1,100 do
				if ((maskEl[hillName].sizeX >= maxLonegerSize) or (maskEl[hillName].sizeZ >= maxLonegerSize) or (maskEl[hillName].sizeX <= minLowerSize) or (maskEl[hillName].sizeZ <= minLowerSize)) then
					hillName 	= setOfHills[terraMath.sinRandomizer(newHash+i,#setOfHills)]
				else
					satisfied 	= true
					break
				end
			end
			if (not satisfied) then
				Spring.Echo("notAmap error: hillType randomization after 100 tries no hill in hills set: " .. hillsSetName .. " was not able to fit condition of size min: " .. minLowerSize .. " max: " .. maxLonegerSize)
			end
		end
		
		-- choose rotation
		newHash				= terraMath.secondaryHashRandomizer(hash)
		local rotation		= mask.hillRotation(terraMath.sinRandomizer(newHash,8))
		
		-- addHill
		-- Spring.Echo(hillName,posX,posZ,rotation)
		digger.addHill(givenMap,hillName,posX,posZ,moveY,rotation)
		
		return givenMap
	end,
	["writeHill"] = function(map,stepsX,stepsZ)
		-- just debug procedure
		local indexes = 0
		for i=1,stepsX do
			local line = ""
			for j=1,stepsZ do
				indexes = indexes + 1
				line = line .. " " .. tostring(map[indexes])
				end
			Spring.Echo(line)
		end
		Spring.Echo("---")
	end,
	-- ["applyTexture"] = function(map,posX,posZ)
		-- Spring.Echo("--test-")
		-- local lame = gl.Texture("$n:/textures/example.png")
		-- local succes = Spring.SetMapSquareTexture(posX,posZ,lame)		
		-- Spring.Echo(succes)
	-- end,
	["oneSimpleMetalSpot"] = function(newX,newZ) --- not using givenMap => use true
		spSetMetalAmount(newX-1,newZ-1,192)
		spSetMetalAmount(newX-1,newZ,256)
		spSetMetalAmount(newX,newZ-1,256)
		spSetMetalAmount(newX-1,newZ+1,256)
		spSetMetalAmount(newX+1,newZ-1,256)
		spSetMetalAmount(newX,newZ,256)
		spSetMetalAmount(newX,newZ+1,256)
		spSetMetalAmount(newX+1,newZ,256)
		spSetMetalAmount(newX+1,newZ+1,192)
		return 1
	end,
	["simpleMetalDigger"] = function(givenMap,numberOfMetalSpots) --- not using givenMap => use true
		local mapX16 = math.floor(mapX/16)
		local mapZ16 = math.floor(mapZ/16)
		for i=1,numberOfMetalSpots do
			local newX = math.random(50,mapX16-50)
			local newZ = math.random(50,mapZ16-50)
			digger.oneSimpleMetalSpot(newX,newZ)
		end
		return givenMap
	end,
	["rectangleMetalDigger"] = function(givenMap,lowX,lowZ,topX,topZ,numberOfMetalSpots) --- not using givenMap => use true
		local mapX16 	= math.floor(mapX/16)
		local mapZ16 	= math.floor(mapZ/16)
		local lowLimitX = math.floor(lowX*mapX16)
		local topLimitX = math.ceil(topX*mapX16)
		local lowLimitZ = math.floor(lowZ*mapX16)
		local topLimitZ = math.ceil(topZ*mapX16)
		for i=1,numberOfMetalSpots do
			local newX = math.random(lowLimitX,topLimitX)
			local newZ = math.random(lowLimitZ,topLimitZ)
			digger.oneSimpleMetalSpot(newX,newZ)
		end
		return givenMap
	end,
	["generalSmooth"] = function(givenMap,deep,prepareForFinal)
		local myK = 131
		for a=1,myK do
			for i=a,mapCount,myK do
			
				-- local upDownIndex			= (heightMap[thisTileNeighborsIDs[1]] or 0 + heightMap[thisTileNeighborsIDs[5]] or 0) / 2
				-- local upRinghtDownLeftIndex	= (heightMap[thisTileNeighborsIDs[2]] or 0 + heightMap[thisTileNeighborsIDs[6]] or 0) / 2
				-- local rightLeft				= (heightMap[thisTileNeighborsIDs[3]] or 0 + heightMap[thisTileNeighborsIDs[7]] or 0) / 2
				-- local downRightUpLeftIndex	= (heightMap[thisTileNeighborsIDs[4]] or 0 + heightMap[thisTileNeighborsIDs[8]] or 0) / 2
				-- heightMap[i] 				= (upDownIndex + upRinghtDownLeftIndex + rightLeft + downRightUpLeftIndex) / 4
				-- Spring.Echo(heightMap[thisTileNeighborsIDs[1]] or 0,heightMap[thisTileNeighborsIDs[2]] or 0,heightMap[thisTileNeighborsIDs[3]] or 0,heightMap[thisTileNeighborsIDs[4]] or 0,heightMap[thisTileNeighborsIDs[5]] or 0,heightMap[thisTileNeighborsIDs[6]] or 0,heightMap[thisTileNeighborsIDs[7]] or 0,heightMap[thisTileNeighborsIDs[8]] or 0,heightMap[i] )
				
				local newHeight = 0
				
				--- DEEP 1
				local thisTileNeighborsIDs 	= mask["neighbors"](i,mapZdivs)
				for j=1,8 do
					newHeight = newHeight + (heightMap[thisTileNeighborsIDs[j]] or 0)
				end

				if (deep == 1) then		
					newHeight = newHeight/8				
				else
					--- DEEP 2
					local thisTileNeighborsIDs 	= mask["neighbors2nd"](i,mapZdivs)
					for k=1,16 do
						newHeight = newHeight + (heightMap[thisTileNeighborsIDs[k]] or 0)
					end
					
					if (deep == 2) then
						newHeight = newHeight/24
					else
						--- DEEP 3
						local thisTileNeighborsIDs 	= mask["neighbors3rd"](i,mapZdivs)
						for l=1,24 do
							newHeight = newHeight + (heightMap[thisTileNeighborsIDs[l]] or 0)
						end
						newHeight = newHeight/48
					end
				end
				
				if (math.abs(heightMap[i]-newHeight) >= 0.5) then
					heightMap[i] = newHeight
					if (prepareForFinal) then
						givenMap[i] = true
					end
				else
					if (prepareForFinal) then
						givenMap[i] = false
					end
				end
			end
		end
		return givenMap
	end,
	["secondarySmooth"] = function(givenMap)
		local myK 			= 131
		local gameSqSize 	= Game.squareSize
		local halfTileSize 	= tileSize/2  -- tileSize is global, set in notAmap.lua
		for a=1,myK do
			for i=a,mapCount,myK do
				local thisTileNeighborsIDs 	= mask["neighbors"](i,mapZdivs)
				local newHeight 			= 0
				local justDifferent			= false
				local thisHeight			= heightMap[i]
				for j=1,8 do
					local tileHeight = heightMap[thisTileNeighborsIDs[j]] or defaultHeightLevel
					newHeight = newHeight + tileHeight
					if (thisHeight ~= tileHeight) then
						justDifferent = true
					end
				end
				newHeight = newHeight/8
				if (justDifferent) then   --- old condition (math.abs(heightMap[i]-newHeight) >= 0.5
					local middleX 		= (math.floor(i/mapZdivs))*tileSize + halfTileSize			--- x position of center of tile
					local middleZ 		= (i % mapZdivs)*tileSize + halfTileSize					--- z position of center of tile
					---- test
					---- !this mean code above is hardcoded juzst for tileSize = 4
					local top			= heightMap[thisTileNeighborsIDs[1]] or defaultHeightLevel
					local topRigth		= heightMap[thisTileNeighborsIDs[2]] or defaultHeightLevel
					local right			= heightMap[thisTileNeighborsIDs[3]] or defaultHeightLevel
					local bottomRight	= heightMap[thisTileNeighborsIDs[4]] or defaultHeightLevel
					local bottom		= heightMap[thisTileNeighborsIDs[5]] or defaultHeightLevel
					local bottomLeft	= heightMap[thisTileNeighborsIDs[6]] or defaultHeightLevel
					local left			= heightMap[thisTileNeighborsIDs[7]] or defaultHeightLevel
					local topLeft		= heightMap[thisTileNeighborsIDs[8]] or defaultHeightLevel
					local center		= heightMap[i]
					
					local tile11 	= (topLeft*3 + top*0 + left*0 + center*5)/8
					local tile12 	= (topLeft*0 + top*3 + left*0 + center*5)/8
					local tile21 	= (topLeft*0 + top*0 + left*3 + center*5)/8
					local tile22 	= (topLeft*1 + top*0 + left*0 + center*7)/8
					local tile13 	= (top*3 + topRigth*0 + right*0 + center*5)/8
					local tile14 	= (top*0 + topRigth*3 + right*0 + center*5)/8
					local tile23 	= (top*0 + topRigth*1 + right*0 + center*7)/8
					local tile24 	= (top*0 + topRigth*0 + right*3 + center*5)/8
					local tile31 	= (left*3 + bottomLeft*0 + bottom*0 + center*5)/8
					local tile32 	= (left*0 + bottomLeft*1 + bottom*0 + center*7)/8
					local tile41 	= (left*0 + bottomLeft*3 + bottom*0 + center*5)/8
					local tile42 	= (left*0 + bottomLeft*0 + bottom*3 + center*5)/8
					local tile33 	= (bottom*0 + bottomRight*1 + right*0 + center*7)/8
					local tile34 	= (bottom*0 + bottomRight*0 + right*3 + center*5)/8
					local tile43 	= (bottom*3 + bottomRight*0 + right*0 + center*5)/8
					local tile44 	= (bottom*0 + bottomRight*3 + right*0 + center*5)/8
					
					-- spLevelHeightMap(middleX - 2*gameSqSize,middleZ - 2*gameSqSize,20)
					-- spLevelHeightMap(middleX - 2*gameSqSize,middleZ - gameSqSize,20)
					-- spLevelHeightMap(middleX - gameSqSize,middleZ - 2*gameSqSize,20)
					-- spLevelHeightMap(middleX - gameSqSize,middleZ - gameSqSize,20)
					-- spLevelHeightMap(middleX - 2*gameSqSize,middleZ,20)
					-- spLevelHeightMap(middleX - 2*gameSqSize,middleZ + gameSqSize,20)
					-- spLevelHeightMap(middleX - gameSqSize,middleZ,20)
					-- spLevelHeightMap(middleX - gameSqSize,middleZ + gameSqSize,20)
					-- spLevelHeightMap(middleX,middleZ - 2*gameSqSize,20)
					-- spLevelHeightMap(middleX,middleZ - gameSqSize,20)
					-- spLevelHeightMap(middleX + gameSqSize,middleZ - 2*gameSqSize,20)
					-- spLevelHeightMap(middleX + gameSqSize,middleZ - gameSqSize,20)
					-- spLevelHeightMap(middleX,middleZ,20)
					-- spLevelHeightMap(middleX,middleZ + gameSqSize,20)
					-- spLevelHeightMap(middleX + gameSqSize,middleZ,20)
					-- spLevelHeightMap(middleX + gameSqSize,middleZ + gameSqSize,20)
					
					spLevelHeightMap(middleX - 2*gameSqSize,middleZ - 2*gameSqSize,tile11)
					spLevelHeightMap(middleX - 2*gameSqSize,middleZ - gameSqSize,tile12)
					spLevelHeightMap(middleX - gameSqSize,middleZ - 2*gameSqSize,tile21)
					spLevelHeightMap(middleX - gameSqSize,middleZ - gameSqSize,tile22)
					spLevelHeightMap(middleX - 2*gameSqSize,middleZ,tile13)
					spLevelHeightMap(middleX - 2*gameSqSize,middleZ + gameSqSize,tile14)
					spLevelHeightMap(middleX - gameSqSize,middleZ,tile23)
					spLevelHeightMap(middleX - gameSqSize,middleZ + gameSqSize,tile24)
					spLevelHeightMap(middleX,middleZ - 2*gameSqSize,tile31)
					spLevelHeightMap(middleX,middleZ - gameSqSize,tile32)
					spLevelHeightMap(middleX + gameSqSize,middleZ - 2*gameSqSize,tile41)
					spLevelHeightMap(middleX + gameSqSize,middleZ - gameSqSize,tile42)
					spLevelHeightMap(middleX,middleZ,tile33)
					spLevelHeightMap(middleX,middleZ + gameSqSize,tile34)
					spLevelHeightMap(middleX + gameSqSize,middleZ,tile43)
					spLevelHeightMap(middleX + gameSqSize,middleZ + gameSqSize,tile44)
					
					-- spLevelHeightMap(middleX - 2*gameSqSize,middleZ - 2*gameSqSize,middleX - gameSqSize,middleZ - gameSqSize,tile11)
					-- spLevelHeightMap(middleX - 2*gameSqSize,middleZ - gameSqSize,middleX - gameSqSize,middleZ,tile12)
					-- spLevelHeightMap(middleX - gameSqSize,middleZ - 2*gameSqSize,middleX,middleZ - gameSqSize,tile21)
					-- spLevelHeightMap(middleX - gameSqSize,middleZ - gameSqSize,middleX,middleZ,tile22)
					-- spLevelHeightMap(middleX - 2*gameSqSize,middleZ,middleX - gameSqSize,middleZ + gameSqSize,tile13)
					-- spLevelHeightMap(middleX - 2*gameSqSize,middleZ + gameSqSize,middleX - gameSqSize,middleZ + 2*gameSqSize,tile14)
					-- spLevelHeightMap(middleX - gameSqSize,middleZ,middleX,middleZ + gameSqSize,tile23)
					-- spLevelHeightMap(middleX - gameSqSize,middleZ + gameSqSize,middleX,middleZ + 2*gameSqSize,tile24)
					-- spLevelHeightMap(middleX,middleZ - 2*gameSqSize,middleX + gameSqSize,middleZ - gameSqSize,tile31)
					-- spLevelHeightMap(middleX,middleZ - gameSqSize,middleX + gameSqSize,middleZ,tile32)
					-- spLevelHeightMap(middleX + gameSqSize,middleZ - 2*gameSqSize,middleX + 2*gameSqSize,middleZ - gameSqSize,tile41)
					-- spLevelHeightMap(middleX + gameSqSize,middleZ - gameSqSize,middleX + 2*gameSqSize,middleZ,tile42)
					-- spLevelHeightMap(middleX,middleZ,middleX + gameSqSize,middleZ + gameSqSize,tile33)
					-- spLevelHeightMap(middleX,middleZ + gameSqSize,middleX + gameSqSize,middleZ + 2*gameSqSize,tile34)
					-- spLevelHeightMap(middleX + gameSqSize,middleZ,middleX + 2*gameSqSize,middleZ + gameSqSize,tile43)
					-- spLevelHeightMap(middleX + gameSqSize,middleZ + gameSqSize,middleX + 2*gameSqSize,middleZ + 2*gameSqSize,tile44)
					---- end of test

					-- local factorMask 	= 
					-- for k = middleX - halfTileSize, middleX + halfTileSize do
						-- for l = middleX - halfTileSize, middleX + halfTileSize do
							
						-- end
					-- end
					givenMap[i] = true
				else
					givenMap[i] = false
				end
			end
		end
		return givenMap
	end,
	["selectedFinalSmooth"] = function(givenMap)
		-- derived from finalSmooth
		Spring.SetHeightMapFunc(function()
			local myK 			= 131
			local sqSize		= Game.squareSize
			local numberOfTiles = (Game.mapSizeX/sqSize)*(Game.mapSizeZ/sqSize)
			local finalZdivs	= math.floor(Game.mapSizeZ/sqSize)			
			for a=1,myK do
				for i=a,numberOfTiles,myK do
					local fakeIndex				= i
					local x						= (math.floor(fakeIndex/finalZdivs))*sqSize
					local z						= (fakeIndex % finalZdivs)*sqSize
					local bigTileID				= terraMath["getIDofTile"](x,z,tileSize,mapZdivs)
					local rightTile 			= givenMap[bigTileID]
					if (rightTile) then
						local justDifferent			= false
						local thisTileNeighborsIDs 	= mask["neighbors"](fakeIndex,finalZdivs)
						local newHeight 			= 0
						local divide				= 0
						local old 					= spGetGroundHeight(x,z)
						for j=1,8 do
							local nX	= (math.floor(thisTileNeighborsIDs[j]/finalZdivs))*sqSize
							local nZ	= (thisTileNeighborsIDs[j] % finalZdivs)*sqSize
							local neigH	= spGetGroundHeight(nX,nZ)
							-- newHeight 	= newHeight + neigH
							if (neigH ~= old) then
								newHeight 	= newHeight + 2*neigH
								divide		= divide + 2
								justDifferent = true
							else
								newHeight 	= newHeight + neigH
								divide		= divide + 1
							end
						end	 
						if (justDifferent) then
							-- newHeight = newHeight/8
							newHeight = newHeight/divide
							-- local dif = math.abs(newHeight - old)							
							-- local final = SmoothTileCount(x,z)
							Spring.SetHeightMap(x,z,newHeight)
							-- Spring.Echo(newHeight + 2*dif,old)
							--Spring.Echo(old,thisTileNeighborsIDs[1],thisTileNeighborsIDs[2],thisTileNeighborsIDs[3],thisTileNeighborsIDs[4])
						end
						--Spring.Echo(x,z,bigTileID,(math.floor(bigTileID/mapZdivs))*tileSize)
					end
				end
			end
		end)
		return givenMap
	end,
	["finalSmooth"] = function(givenMap)
		-- local function SmoothTileCount(x,z)
			-- local height 		= 0
			-- height = height + Spring.GetGroundHeight(x-Game.squareSize,z-Game.squareSize) or 0
							-- + Spring.GetGroundHeight(x-Game.squareSize,z) or 0
							-- + Spring.GetGroundHeight(x-Game.squareSize,z+Game.squareSize) or 0
							-- + Spring.GetGroundHeight(x,z-Game.squareSize) or 0 
							-- + Spring.GetGroundHeight(x,z+Game.squareSize) or 0
							-- + Spring.GetGroundHeight(x+Game.squareSize,z-Game.squareSize) or 0
							-- + Spring.GetGroundHeight(x+Game.squareSize,z) or 0
							-- + Spring.GetGroundHeight(x+Game.squareSize,z+Game.squareSize) or 0
							
							-- + Spring.GetGroundHeight(x,z)
			-- return height/9
		-- end
		-- ?? btw when i did it with x+-1*Game.squareSize etc. it was nice resizing, like minimap making
		
		spSetHeightMapFunc(function()
			local myK 			= 131
			local numberOfTiles = (Game.mapSizeX/Game.squareSize)*(Game.mapSizeZ/Game.squareSize)
			local finalZdivs	= math.floor(Game.mapSizeZ/Game.squareSize)
			for a=1,myK do
				for i=a,numberOfTiles,myK do   -- (1)
				--for i=a,mapCount,myK do			-- (2)
					--if (givenMap[i]) then         -- (2)
						local fakeIndex				= i
						local thisTileNeighborsIDs 	= mask["neighbors"](fakeIndex,finalZdivs)
						local newHeight 			= 0
						local x 					= (math.floor(fakeIndex/finalZdivs))*Game.squareSize
						local z						= (fakeIndex % finalZdivs)*Game.squareSize
						local justDifferent			= false
						local old 					= spGetGroundHeight(x,z)
						for j=1,8 do
							local nX	= (math.floor(thisTileNeighborsIDs[j]/finalZdivs))*Game.squareSize
							local nZ	= (thisTileNeighborsIDs[j] % finalZdivs)*Game.squareSize
							local neigH	= spGetGroundHeight(nX,nZ)
							newHeight 	= newHeight + neigH
							if (neigH ~= old) then
								justDifferent = true
							end
						end	 
						if (justDifferent) then
							newHeight = newHeight + old
							-- local final = SmoothTileCount(x,z)
							spSetHeightMap(x,z,newHeight/9)
							--Spring.Echo(old,thisTileNeighborsIDs[1],thisTileNeighborsIDs[2],thisTileNeighborsIDs[3],thisTileNeighborsIDs[4])
						end
						--Spring.Echo(i)
					--end	 -- (2)
				end
			end
		end)
		
		-- for i=1,mapCount do
			-- local x = math.floor(tileID/mapZdivs)
			-- local z = tileID % mapZdivs
			-- SmoothTile(i,x,z)
		-- end
		return givenMap
	end,
	["applyChanges"] = function(givenMap)
		local function SetFinalHeight()
			for i=0,mapXdivs-1 do
				for j=0,mapZdivs-1 do
					local tileID = i*mapZdivs+j+1
					if (heightMap[tileID] ~= defaultHeightLevel) then
						--spSetHeightMap(i*tileSize,j*tileSize,heightMap[tileID],0)
						spLevelHeightMap(i*tileSize,j*tileSize,i*tileSize+tileSize,j*tileSize+tileSize,heightMap[tileID])
					end
				end
			end
		end
		spSetHeightMapFunc(SetFinalHeight)
		return givenMap
	end
}