----- notAmap FILTERS LIBRARY -----

filter = {
	--- ORDINARY ---
	["getRectangle"] = function(givenMap,valid,posX,posZ,limitOne,limitTwo)
		local lowXlimit,highXlimit,lowZlimit,highZlimit
		if (limitTwo ~= nil) then
			lowXlimit 		= floor(posX*mapXdivs)
			highXlimit 		= floor(limitOne*mapXdivs)
			lowZlimit 		= floor(posZ*mapZdivs)
			highZlimit 		= floor(limitTwo*mapZdivs)
		else
			local idPosX	= floor(posX*mapXdivs)
		    local idPosZ	= floor(posZ*mapZdivs)
			lowXlimit 		= idPosX - floor(limitOne*mapXdivs)
			highXlimit 		= idPosX + floor(limitOne*mapXdivs)
			lowZlimit 		= idPosZ - floor(limitOne*mapZdivs)
			highZlimit 		= idPosZ + floor(limitOne*mapZdivs)
		end
		for i=lowXlimit,highXlimit do
			for j=lowZlimit,highZlimit do
				givenMap[i*mapZdivs+j+1] = valid
			end
		end
		-- debug --
		--Spring.Echo(mapXdivs,mapZdivs,lowXlimit,highXlimit,lowZlimit,highZlimit)
		--filter["mapWriter"](givenMap)
		return givenMap
	end,
	["getDetCentredRectangle"] = function(givenMap,valid,posX,posZ,masking,range,size,position,name)
		local newCenterList = mask[masking](posX,posZ,range)
		local newCenter		
		if (position >= 1 and position <= 8) then
			newCenter = newCenterList[position]
		else
			newCenter = {posX,posZ}
		end
		local halfSize		= size/2
		
		if (name ~= nil) then
			filter.posKnowledge(name,newCenter[1],newCenter[2])
		end
		
		return filter["getRectangle"](givenMap,valid,newCenter[1]-halfSize,newCenter[2]-halfSize,newCenter[1]+halfSize,newCenter[2]+halfSize)
	end,
	["getCentredRectRing"] = function(givenMap,low,high)
		local halfXdivs		= floor(mapXdivs/2)
		local halfZdivs		= floor(mapZdivs/2)
		local lowXlimit 	= floor(low * (mapXdivs/2))
		local highXlimit 	= floor(high * (mapXdivs/2))
		local lowZlimit 	= floor(low * (mapZdivs/2))
		local highZlimit 	= floor(high * (mapZdivs/2))
		for i=0,mapXdivs-1 do
			for j=0,mapZdivs-1 do
				--Spring.Echo(i,halfXdivs-highXlimit,i,halfXdivs+highXlimit,j,halfZdivs-highZlimit,j,halfZdivs+highZlimit)
				--Spring.Echo(i,halfXdivs-lowXlimit,i,halfXdivs+lowXlimit,j,halfZdivs-lowZlimit,j,halfZdivs+lowZlimit)
				--Spring.Echo("----")
				local outerLimit = (i>halfXdivs-highXlimit) and (i<halfXdivs+highXlimit) and (j>halfZdivs-highZlimit) and (j<halfZdivs+highZlimit)
				local closerLimit = (i<halfXdivs-lowXlimit) or (i>halfXdivs+lowXlimit) or (j<halfZdivs-lowZlimit) or (j>halfZdivs+lowZlimit)
				if (outerLimit and closerLimit) then
					givenMap[i*mapZdivs+j+1] = true
				end
			end
		end
		-- debug --
		--Spring.Echo(mapXdivs,mapZdivs,lowXlimit,highXlimit,lowZlimit,highZlimit)
		--filter["mapWriter"](givenMap)
		return givenMap
	end,
	["findCoast"] = function(givenMap,coefOne,maxtiles,sectors)
		-- tools --
		local function NeighborsLandCounter(thisTileID,thisTileNeighbors)
			local neighborsLand	= 0
			for i=1,8 do
				--Spring.Echo(thisTileNeighbors[i],givenMap[thisTileNeighbors[i]])	
				if (not givenMap[thisTileNeighbors[i]]) then
					neighborsLand = neighborsLand + 1
				end
			end
			return neighborsLand
		end
		-- local sectors = {
			-- [1] = {0,0,0.5,0.5},
			-- [2] = {0.5,0.5,1,0.5},
			-- [3] = {0,0.5,0.5,1},
			-- [4] = {0.5,0.5,1,1},
		-- }
		-- local sectors = {
			-- [1] = {0,0,1,1},
			-- [2] = {0.3,0.3,0.7,0.7},
		-- }
		
		-- start --
		for a=1,#sectors do
			local lowXlimit 	= floor(sectors[a][1] * mapXdivs)
			local highXlimit 	= floor(sectors[a][3] * mapXdivs)
			local lowZlimit 	= floor(sectors[a][2] * mapZdivs)
			local highZlimit 	= floor(sectors[a][4] * mapZdivs)
			local listOfTiles	= {}
			local numberOfTiles = 0
			--Spring.Echo("Sector " .. a)
			for i=lowXlimit,highXlimit-1 do
				for j=lowZlimit,highZlimit-1 do
					local tileID = i*mapZdivs+j+1
					
					-- Spring.Echo("---")
					-- local thisTileNeighborsB = mask["neighbors"](tileID,mapZdivs)
					-- local neighborsLandB	 = NeighborsLandCounter(tileID,thisTileNeighborsB)
					-- for k=1,8 do
						-- Spring.Echo(thisTileNeighborsB[k],givenMap[thisTileNeighborsB[k]])						
					-- end
					-- Spring.Echo("=", neighborsLandB)
					-- if (true) then
						-- break
					-- end
					
					if (givenMap[tileID]) then
						local thisTileNeighbors 	= mask["neighbors"](tileID,mapZdivs)
						local thisTileNeighborsLand	= NeighborsLandCounter(tileID,thisTileNeighbors)
						if ((thisTileNeighborsLand >= 3) and (thisTileNeighborsLand <= 7)) then
							numberOfTiles 				= numberOfTiles + 1
							listOfTiles[numberOfTiles] 	= tileID
						end
				    end
				end
			end
			-- ! maybe some randomization here
			for i=1,maxtiles[a] do
				local tileID = listOfTiles[i]
				if (tileID) then
					if (givenMap[tileID]) then
						local thisTileNeighbors 	= mask["neighbors"](tileID,mapZdivs)
						local thisTileNeighborsLand	= NeighborsLandCounter(tileID,thisTileNeighbors)
						-- local yes = random() + (0.5 - thisTileNeighborsLand/10) -- 00 (180000)
						-- local yes = random() + (0.5 - thisTileNeighborsLand/5)	-- 01 (180000)
						-- local yes = random() + (1 - thisTileNeighborsLand/3)	-- 02 (180000)
						-- local yes = random() + (1 - thisTileNeighborsLand/2)	-- 03 (180000)
						local yes = random() + (1 - thisTileNeighborsLand/coefOne)
						---- now: if choosen, make Land and check neighbors, if not, add it at the end
						if (yes >= 1 or thisTileNeighborsLand >= 5) then      
							givenMap[tileID] = false
							for j=1,8 do
								local neighborTileID 				= thisTileNeighbors[j]
								if (givenMap[neighborTileID]) then
									local neighborTileNeighbors			= mask["neighbors"](neighborTileID,mapZdivs)
									local neighborTileNeighborsLand		= NeighborsLandCounter(neighborTileID,thisTileNeighbors)
									if ((neighborTileNeighborsLand >= 3) and (neighborTileNeighborsLand <= 7)) then
										numberOfTiles 				= numberOfTiles + 1
										listOfTiles[numberOfTiles] 	= neighborTileID
									end
								end
							end
						else
							numberOfTiles 				= numberOfTiles + 1
							listOfTiles[numberOfTiles] 	= tileID
						end
					end
				end
			end
		end
		return givenMap
	end,
	--- SPECIAL ---
	["fullActiveMap"] = function()
		local filterMap = {}
		for i=1,mapCount do
			filterMap[i] = true
		end
		return filterMap
	end,
	["fullNotActiveMap"] = function()
		local filterMap = {}
		for i=1,mapCount do
			filterMap[i] = false
		end
		return filterMap
	end,
	["negativeMap"] = function(givenMap)
		for i=1,mapCount do
			givenMap[i] = not(givenMap[i])
		end
		return givenMap
	end,
	["mapWriter"] = function(givenMap)
		for i=0,mapXdivs-1 do
			for j=0,mapZdivs-1 do
				Spring.Echo(i+1,j+1,tostring(givenMap[i*mapZdivs+j+1]))
			end
		end
		return givenMap
	end,
	["posKnowledge"] = function(name,x,z)
		mapKnowledge[name] = {}
		mapKnowledge[name]["x"] = x
		mapKnowledge[name]["z"] = z
	end,
}