----- notAmap MASKS LIBRARY -----

mask = {

    -- parametrized --
	["neighbors"] = function(tileNumber,zSize)
		local tilesArray = {
			[1]  = tileNumber - 1,			-- up
			[2]  = tileNumber + zSize - 1,	-- uppright
			[3]  = tileNumber + zSize,		-- right
			[4]  = tileNumber + zSize + 1,	-- downright
			[5]  = tileNumber + 1,			-- down
			[6]  = tileNumber - zSize + 1,	-- downleft
			[7]  = tileNumber - zSize,		-- left
			[8]  = tileNumber - zSize - 1,	-- upleft
		}
		return tilesArray
	end,
	["neighbors2nd"] = function(tileNumber,zSize)
		local zSize2 		= 2*zSize
		local tilesArray 	= {
			[1]  = tileNumber - 2,			-- up
			[2]  = tileNumber + zSize - 2,	
			[3]  = tileNumber + zSize2 - 2,		
			[4]  = tileNumber + zSize2 - 1,	
			[5]  = tileNumber + zSize2,			
			[6]  = tileNumber + zSize2 + 1,	
			[7]  = tileNumber + zSize2 + 2,		
			[8]  = tileNumber + zSize + 2,	
			[9]  = tileNumber + 2,			
			[10] = tileNumber - zSize + 2,	
			[11] = tileNumber - zSize2 + 2,		
			[12] = tileNumber - zSize2 + 1,	
			[13] = tileNumber - zSize2,			
			[14] = tileNumber - zSize2 - 1,	
			[15] = tileNumber - zSize2 - 2,		
			[16] = tileNumber - zSize - 2,	
		}
		return tilesArray
	end,
	["neighbors3rd"] = function(tileNumber,zSize)
		local zSize2 		= 2*zSize
		local zSize3 		= 3*zSize
		local tilesArray 	= {
			[1]  = tileNumber - 3,			-- up
			[2]  = tileNumber + zSize - 3,	
			[3]  = tileNumber + zSize2 - 3,	
			[4]  = tileNumber + zSize3 - 3,				
			[5]  = tileNumber + zSize3 - 2,	
			[6]  = tileNumber + zSize3 - 1,			
			[7]  = tileNumber + zSize3,	
			[8]  = tileNumber + zSize3 + 1,		
			[9]  = tileNumber + zSize3 + 2,	
			[10]  = tileNumber + zSize3 + 3,			
			[11] = tileNumber + zSize2 + 3,	
			[12] = tileNumber + zSize + 3,		
			[13] = tileNumber + 3,	
			[14] = tileNumber - zSize + 3,			
			[15] = tileNumber - zSize2 + 3,	
			[16] = tileNumber - zSize3 + 3,		
			[17] = tileNumber - zSize3 + 2,	
			[18] = tileNumber - zSize3 + 1,			
			[19] = tileNumber - zSize3,	
			[20] = tileNumber - zSize3 - 1,		
			[21] = tileNumber - zSize3 - 1,	
			[22] = tileNumber - zSize3 - 3,			
			[23] = tileNumber - zSize2 - 3,	
			[24] = tileNumber - zSize - 3,		
		}
		return tilesArray
	end,
	["farNeighbors"] = function(tileNumber,zSize,distance)
		local tilesArray = {
			[1]  = tileNumber - distance,			-- up
			[2]  = tileNumber + zSize - distance,	-- uppright
			[3]  = tileNumber + zSize,				-- right
			[4]  = tileNumber + zSize + distance,	-- downright
			[5]  = tileNumber + distance,			-- down
			[6]  = tileNumber - zSize + distance,	-- downleft
			[7]  = tileNumber - zSize,				-- left
			[8]  = tileNumber - zSize - distance,	-- upleft
		}
		return tilesArray
	end,
	["ringPosition"] = function(CenterX,CenterZ,radius)
		local tilesArray = {
			[1]  = {CenterX,CenterZ - radius},			-- up
			[2]  = {CenterX + radius,CenterZ - radius},	-- uppright
			[3]  = {CenterX + radius,CenterZ},			-- right
			[4]  = {CenterX + radius,CenterZ + radius},	-- downright
			[5]  = {CenterX,CenterZ + radius},			-- down
			[6]  = {CenterX - radius,CenterZ + radius},	-- downleft
			[7]  = {CenterX - radius,CenterZ},			-- left
			[8]  = {CenterX - radius,CenterZ - radius},	-- upleft
		}
		return tilesArray
	end,
	["circlePosition"] = function(CenterX,CenterZ,radius)
		local smallRad = (1 - sin(1/4))*radius
		local tilesArray = {
			[1]  = {CenterX,CenterZ - radius},				-- up
			[2]  = {CenterX + smallRad,CenterZ - smallRad},	-- uppright
			[3]  = {CenterX + radius,CenterZ},				-- right
			[4]  = {CenterX + smallRad,CenterZ + smallRad},	-- downright
			[5]  = {CenterX,CenterZ + radius},				-- down
			[6]  = {CenterX - smallRad,CenterZ + smallRad},	-- downleft
			[7]  = {CenterX - radius,CenterZ},				-- left
			[8]  = {CenterX - smallRad,CenterZ - smallRad},	-- upleft
		}
		return tilesArray
	end,
	["advancedCirclePosition"] = function(CenterX,CenterZ,radius)
		local smallRad  = (1 - sin(7/8))*radius
		local bigRad	= (1 - sin(1/8))*radius
		local tilesArray = {
			[1]  = {CenterX + smallRad,CenterZ - bigRad},	-- upright
			[2]  = {CenterX + bigRad,CenterZ - smallRad},	-- rightup
			[3]  = {CenterX + bigRad,CenterZ + smallRad},	-- rightdown
			[4]  = {CenterX + smallRad,CenterZ + bigRad},	-- downright
			[5]  = {CenterX - smallRad,CenterZ + bigRad},	-- downleft
			[6]  = {CenterX - bigRad,CenterZ + smallRad},	-- leftdown
			[7]  = {CenterX - bigRad,CenterZ - smallRad},	-- leftup
			[8]  = {CenterX - smallRad,CenterZ - bigRad},	-- upleft
		}
		return tilesArray
	end,
	["revertRing"] = function(posNumber)
		local tilesArray = {
			[0]  = 6,	-- zero
			----
			[1]  = 5,	-- up
			[2]  = 6,	-- uppright
			[3]  = 7,	-- right
			[4]  = 8,	-- downright
			[5]  = 1,	-- down
			[6]  = 2,	-- downleft
			[7]  = 3,	-- left
			[8]  = 4,	-- upleft
			----
			[9]  = 5,	-- upleft	
		}
		return tilesArray[posNumber]
	end,
	["hillRotation"] = function(posNumber)
		local tilesArray = {
			[1]  = "n",		-- north (default)
			[2]  = "e",		-- east
			[3]  = "s",		-- south
			[4]  = "w",		-- west
			[5]  = "nr",	-- north reversed
			[6]  = "er",	-- east reversed
			[7]  = "sr",	-- south reversed
			[8]  = "wr",	-- west reversed
		}
		return tilesArray[posNumber]
	end,
	["allHills"] = function()
		local allHillsNames = {}
		local counter 		= 0
		
		for k,v in pairs(maskEl) do
			counter 				= counter + 1
			allHillsNames[counter] 	= k 
		end
		
		return allHillsNames
	end,
	["allArchHills"] = function()
		local allHillsNames = {}
		local counter 		= 0
		
		for k,v in pairs(maskEl) do
			local startPos,endPos = string.find(k,"arch")
			if (endPos ~= nil and k~="parch2") then
				counter 				= counter + 1
				allHillsNames[counter] 	= k 
			end
		end
		
		return allHillsNames
	end,
	["allNonArchHills"] = function()
		local allHillsNames = {}
		local counter 		= 0
		
		for k,v in pairs(maskEl) do
			local startPos,endPos = string.find(k,"arch")
			if (endPos == nil) then
				counter 				= counter + 1
				allHillsNames[counter] 	= k 
			end
		end
		
		return allHillsNames
	end,

}