----- notAmap TERRaMATH LIBRARY -----

terraMath = {

	-- getID --
	["getIDofTile"] = function(posX,posZ,thisDivision,zdivs)
		local ID = 0
		ID = math.floor(posX/thisDivision)*zdivs + math.ceil(posZ/thisDivision)
		if (ID == 0) then Spring.Echo("notAmap generator: asked tile is not on map") end
		return ID
	end,
	["getXZfromID"] = function(tileID)
		local x = math.floor(tileID/mapZdivs)
		local z = tileID % mapZdivs
		return x,z
	end,
	
	-- distances --
	["getDistance2D"] = function(firstX,firstZ,secondX,secondZ)
		local result = math.sqrt((firstX-secondX)*(firstX-secondX) + (firstZ-secondZ)*(firstZ-secondZ))
		return result
	end,
	["getDistance2DSQ"] = function(firstX,firstZ,secondX,secondZ)
		return (firstX-secondX)*(firstX-secondX) + (firstZ-secondZ)*(firstZ-secondZ)
	end,
	
	-- mapRotators --
	["mapHorizontalReverse"] = function(map,stepsX,stepsZ)
		local newMap = {}
		
		local newIndex = 0
		for i=stepsX,1,-1 do
			for j=1,stepsZ do
				local oldIndex = (i-1)*stepsZ + j
				newIndex = newIndex + 1
				newMap[newIndex] = map[oldIndex]
			end
		end
		
		return newMap
	end,
	["mapVerticalReverse"] = function(map,stepsX,stepsZ)
		local newMap = {}
		
		local newIndex = 0
		for i=1,stepsX do
			for j=stepsZ,1,-1 do
				local oldIndex = (i-1)*stepsZ + j
				newIndex = newIndex + 1
				newMap[newIndex] = map[oldIndex]
			end
		end
		
		return newMap
	end,
	["mapRotationRight"] = function(map,stepsX,stepsZ)
		local newMap = {}
		
		local newIndex = 0
		for i=stepsZ,1,-1 do
			for j=1,stepsX do
				local oldIndex = (j-1)*stepsZ + i
				newIndex = newIndex + 1
				newMap[newIndex] = map[oldIndex]
			end
		end
		
		return newMap
	end,	
	["mapRotationLeft"] = function(map,stepsX,stepsZ)
		local newMap = {}
		
		local newIndex = 0
		for i=stepsX,1,-1 do
			for j=1,stepsZ do
				local oldIndex = (j-1)*stepsZ + i
				newIndex = newIndex + 1
				newMap[newIndex] = map[oldIndex]
			end
		end
		
		return newMap
	end,

	-- randomizators --
	["sinRandomizer"] = function(hash,members)
		return floor((((sin(hash) + 1)/2) * members) + 1)
	end,
	["cosRandomizer"] = function(hash,members)
		return floor((((cos(hash) + 1)/2) * members) + 1)
	end,
	["secondaryHashRandomizer"] = function(hash)
		return random(1,hash+8)
	end,
	["zeroToSmallRandomizer"] = function(hash,division,mult)
		local value = (random(1,hash+100) % division) * mult
		-- value = string.sub(tostring(value),1,5)
		-- Spring.Echo(value)
		return value
	end,
}